﻿package 
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.FullScreenEvent;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.utils.setInterval;

	public class Liner extends Sprite
	{
		public var balls:Array
		public function Liner()
		{
			balls = new Array();
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
		}
		
		private function addedHandler(e:Event):void
		{
			stage.addEventListener(FullScreenEvent.FULL_SCREEN,fullhandler);
			setInterval(buildScreen,15);
			stage.addEventListener(MouseEvent.CLICK,clickHandler);
		}
		private function fullhandler(e:FullScreenEvent):void
		{
			balls = new Array();
		}
		private function clickHandler(e:MouseEvent):void
		{
			var pt:Point = new Point(e.stageX,e.stageY);
			var obj:Object = {"posx":this.globalToLocal(pt).x,"posy":this.globalToLocal(pt).y,"angle":0,"rayon":(Math.random()*100 + 100),"centerY":this.globalToLocal(pt).y};
			balls.push(obj);
			balls.sortOn(["posx"],[Array.NUMERIC]);
		}
		
		private function buildScreen():void
		{
			this.graphics.clear();
			for(var i:Number =0;i<balls.length;i++	){
				graphics.beginFill(Math.random()*0x00ff60);
				graphics.drawRect(balls[i].posx,balls[i].posy,Math.random()*5,Math.random()*100);
				graphics.endFill();
				graphics.lineStyle(Math.random()*1,Math.random()*0x00ff60,Math.random()*10);
				//draw the lines
				if(i>0){
					graphics.moveTo(balls[i-1].posy,balls[i-1].pos);
					graphics.lineTo(balls[i].posx,balls[i].posy);
				}
				graphics.lineStyle();
				//set the new position
				balls[i].posy = balls[i].centerY + Math.sin(balls[i].angle*Math.PI/190)*balls[i].rayon;
				balls[i].angle++;
			}
		}
	}
}